/*
ROMCHECK16.C

this utility receives one argument - a filename.

it computes the 'checksum' of a file as listed in Studer docs
*/

#include <stdlib.h>
#include <stdio.h>

int
main(int argc, char *argv[])
{
  FILE *romfile;
  unsigned char byte;
  unsigned short ck;
  size_t len;

  if (argc<2) return EXIT_FAILURE;

  if((romfile=fopen(argv[1],"rb"))==0)
    return EXIT_FAILURE;

  len=ck=0;

  while(fread(&byte,1,1,romfile))
    {
      ck+=byte;
      len++;
    }
  
  if(feof(romfile))
    {
      printf("read %d bytes from %s\n",len,argv[1]);
      printf("checksum  = %x\n",ck);
      fclose(romfile);
      return EXIT_SUCCESS;
    }
  else
    return EXIT_FAILURE;
}

